#include <iostream>
#include <math.h>
#include <vector>
#include "histogram.h"
using namespace std;

void
find_minmax(const vector<double> &numbers, double& min, double& max)
{

    min = numbers[0];
    max = numbers[0];
    for (size_t i = 0; i < numbers.size(); i++)
    {
        if (numbers[i] > max)
            max = numbers[i];
        if (numbers[i] < min)
            min = numbers[i];
    }
}

vector<size_t> make_histogram (const vector<double>& numbers, size_t &bin_count)
{
   vector <size_t> bins(bin_count);

   double min, max;
   float low, hi;

   find_minmax(numbers, min, max);

   double bin_size = (max - min) / bin_count;
   low = min;
   hi = low + bin_size;

   for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;

        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            low = min + j * bin_size;
            hi = min + (j + 1) * bin_size;
            if ((low <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (found==false)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}
